<template>
    <form>
        <div class="form-group">
            <label for="first_name">Nombre</label>
            <input type="text" class="form-control"
                   v-bind:class="{ 'is-invalid': errors.first_name }"
                   name="first_name" v-model="model.first_name" required>
            <span class="invalid-feedback" role="alert" v-if="errors.first_name !== null">
                <strong v-for="msg in errors.first_name">{{ msg }}</strong>
            </span>
        </div>
        <div class="form-group">
            <label for="last_name">Apellidos</label>
            <input type="text" class="form-control"
                   name="last_name" v-model="model.last_name"
                   v-bind:class="{ 'is-invalid': errors.last_name }" required>
            <span class="invalid-feedback" role="alert" v-if="errors.last_name !== null">
                <strong v-for="msg in errors.last_name">{{ msg }}</strong>
            </span>
        </div>
        <div class="form-group">
            <label for="email">Correo electrónico</label>
            <input type="email" class="form-control" name="email"
                   v-model="model.email" autocomplete="off" required
                   v-bind:class="{ 'is-invalid': errors.email }">
            <span class="invalid-feedback" role="alert" v-if="errors.email !== null">
                <strong v-for="msg in errors.email">{{ msg }}</strong>
            </span>
        </div>
        <div class="form-group">
            <label for="password">Contraseña</label>
            <input type="password" class="password form-control" v-bind:required="passwordIsRequired"
                   name="password" v-bind:class="{ 'is-invalid': errors.password }"
                   v-model="model.password">
            <small class="form-text text-muted" v-if="mode === 'edit'">
                Solo editar para cambiar la contraseña
            </small>
            <span class="invalid-feedback" role="alert" v-if="errors.password !== null">
                <strong v-for="msg in errors.password">{{ msg }}</strong>
            </span>
        </div>
        <div class="form-group">
            <label for="password-confirm">Confirmar contraseña</label>
            <input type="password" class="form-control"
                   name="password_confirmation" v-bind:required="passwordIsRequired"
                   v-bind:class="{ 'is-invalid': errors.password_confirmation }"
                   v-model="model.password_confirmation">
            <small class="form-text text-muted" v-if="mode === 'edit'">
                Solo editar para cambiar la contraseña
            </small>
        </div>
        <div class="form-group">
            <label>Foto de perfil</label>
            <image-picker ref="imagePicker"
                data-ratio="1"
                file-contents="profile_photo"
                file-names="profile_photo_filename"
                src-image="#">
            </image-picker>
        </div>
    </form>
</template>

<script>
import vSelect from 'vue-select';
import FormMixin from '../../mixins/FormMixin.vue';
import ImagePicker from '../../components/ImagePicker.vue';
import utils from '../../utils.js';

export default {
    mixins: [FormMixin],
    components: {
        'image-picker': ImagePicker,
        'v-select': vSelect
    },
    data() {
        let data = {
            mode: 'create',
            fields: [
                'id', 'first_name', 'last_name', 'email',
                'password', 'password_confirmation'
            ],
            model: {},
            errors: {}
        };
        _.each(data.fields, function(field) {
            data.model[field] = null;
            data.errors[field] = null;
        });
        return data;
    },
    computed: {
        passwordIsRequired() {
            return this.mode === 'create';
        }
    },
    methods: {
        create() {
            var vm = this;
            _.each(this.fields, function(field) {
                vm.model[field] = null;
            });
            this.$refs.imagePicker.urlImage = null;
            this.mode = 'create';
        },
        edit(record) {
            this.setData(record);
            this.mode = 'edit';
        },
        setData(record) {
            this.model.id = record.id;
            this.model.first_name = record.first_name;
            this.model.last_name = record.last_name;
            this.model.email = record.email;
            this.model.password = '********';
            this.model.password_confirmation = '********';
            this.$refs.imagePicker.urlImage = record.profile_photo !== null ? (record.profile_photo.path) : null;
        },
        saveModel(onSuccess, onResponse, onInvalidForm) {
            var method = this.mode === 'create' ? 'post' : 'put';
            var url = this.mode === 'create' ? '/ajax/users' : '/ajax/users/' + this.model.id;
            if (this.mode === 'profile') {
                url = '/ajax/users/me';
            }
            var vm = this;
            this.model.profile_photo = null;
            if (this.$refs.imagePicker.urlImage !== null) {
                if (this.$refs.imagePicker.urlImage.startsWith('data:image/')) {
                    this.model.profile_photo = {
                        name: this.$refs.imagePicker.filename,
                        contents: this.$refs.imagePicker.urlImage
                    };
                }
            }
            let data = _.clone(this.model);
            // Guardar datos
            this.save(method, url, data, {
                onSuccess,
                onResponse,
                onInvalidForm
            });
        },
        setMode(mode) {
            this.mode = mode;
        }
    }
};
</script>

<style>
</style>